use super::schema::member_sessions;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, Debug, Clone)]
#[table_name = "member_sessions"]
pub struct MemberSession {
  ///
  pub id: uuid::Uuid,
  ///
  pub member_id: uuid::Uuid,
  ///
  pub ip: String,
  ///
  pub last_accessed_at: i64,
  ///
  pub expires_at: i64,
  ///
  pub created_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "member_sessions"]
pub struct NewMemberSession {
  ///
  pub member_id: uuid::Uuid,
  ///
  pub ip: String,
  ///
  pub expires_at: i64,
}

///
#[derive(AsChangeset, Debug, Clone)]
#[table_name = "member_sessions"]
pub struct ModifyMemberSessionForLastAccess {
  ///
  pub last_accessed_at: i64,
  ///
  pub expires_at: i64,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub member_id: Option<uuid::Uuid>,
}

///
#[derive(Debug, Clone)]
pub struct FindAll {
  ///
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::pagination::Sort>>,
}
